;***************************************
;THIS PROGRAM FOR TEST GRAPHIC LCD
;240 X 64 DOTS FOR GRAPHIC MODE
;HARDWARE :CP-SB31 V2.0
;SOFTWARE :SXA51.EXE
;COMPANY  :ETT CO.,LTD.
;DATE     :16/11/1999
;***************************************
;
HIADD   EQU     30H
LOADD   EQU     31H
TEMP    EQU     32H
LINE    EQU     33H
LOBUF   EQU     34H
HIBUF   EQU     35H
COL     EQU     36H
RESULT  EQU     37H
BUF1    EQU     22H
BUF2    EQU     23H
BASE0   EQU     0000H
BASE1   EQU     BASE0+40
BASE2   EQU     BASE0+80
BASE3   EQU     BASE0+120
BASE4   EQU     BASE0+160
BASE5   EQU     BASE0+200

        ORG     8000H
MAIN:   CALL    INITG          ;Initial GRAPHIC MODE
        CALL    DOFF           ;DISPLAY  OFF
        CALL    CGM            ;Clear graphic display
        MOV     R5,#10
        MOV     R6,#7
        MOV     DPTR,#PATG1
        CALL    PUT		;Put pattern
        INC     COL
        CALL    DON             ;DISPLAY ON
        CALL    DEL		;delay
        CALL    INITC		;swap mode to character mode
        CALL    CCM             ;Clear character display
        MOV     DPTR,#BASE0
        CALL    SCP
        MOV     DPTR,#TABSTR1
        CALL    WRST             ;write string
        MOV     DPTR,#BASE1
        CALL    SCP
        MOV     DPTR,#TABSTR2
        CALL    WRST
        MOV     DPTR,#BASE2
        CALL    SCP
        MOV     DPTR,#TABSTR3
        CALL    WRST
        MOV     DPTR,#BASE3
        CALL    SCP
        MOV     DPTR,#TABSTR4
        CALL    WRST
        MOV     DPTR,#BASE4
        CALL    SCP
        MOV     DPTR,#TABSTR5
        CALL    WRST
        CALL    DEL
        SJMP    MAIN          ;goto main
;****************************************
; CLEAR DISPLAY (BLANK DISPLAY)
;****************************************
CGM:    MOV     DPTR,#0000
        LCALL   SCP
        MOV     LOADD,#0
        MOV     R6,#64          ;64 LINES
LL:     MOV     R0,#0CH         
        MOV     R1,#0FFH
        LCALL   WRI
        MOV     A,LOADD
        ADD     A,#1
        MOV     LOADD,A
        CJNE    A,#30,LL       ;30 BYTES PER LINE
        MOV     LOADD,#00
        DJNZ    R6,LL
        RET
;****************************************
;PUT ONE LINE
;INPUT :DPTR 
;****************************************
PPT:    MOV     R4,#5
PP1:    MOV     A,#0
        MOVC    A,@A+DPTR
        CALL    ROT
        MOV     R1,A
        CALL    WRCHR
        INC     DPTR
        DJNZ    R4,PP1
        RET
;***************************************
;ROTATE
;INPUT  :A
;OUTPUT :BUF1
;***************************************
ROT:    MOV     BUF1,#0
        RLC     A
        MOV     BUF1.0,C
        RLC     A
        MOV     BUF1.1,C
        RLC     A
        MOV     BUF1.2,C
        RLC     A
        MOV     BUF1.3,C
        RLC     A
        MOV     BUF1.4,C
        RLC     A
        MOV     BUF1.5,C
        RLC     A
        MOV     BUF1.6,C
        RLC     A
        MOV     BUF1.7,C
        MOV     A,BUF1
        RET
;****************************************
;PUT PATTERN
;INPUT :R5   = LINE
;      :R6   = COL
;      :DPTR = PATTERN 
;****************************************
PUT:    MOV     R3,#40
        MOV     LINE,R5                 ;START LINE 0-63
        ;MOV     COL,R6                  
        MOV     LOBUF,DPL
        MOV     HIBUF,DPH
PUT1:   MOV     A,LINE
        MOV     B,#30
        MUL     AB
        CLR     CY
        ADD     A,COL
        JNC     NN
        INC     B
NN:     MOV     DPL,A
        MOV     DPH,B
        CALL    SCP
        MOV     DPL,LOBUF
        MOV     DPH,HIBUF
        CALL    PPT
        MOV     A,LOBUF
        CLR     CY
        ADD     A,#5
        JNC     PUT2
        MOV     LOBUF,#00
        INC     HIBUF
PUT2:   MOV     LOBUF,A
        INC     LINE
        DJNZ    R3,PUT1
        RET
;****************************************
; CLEAR DISPLAY (BLANK DISPLAY)
;****************************************
CCM:    MOV     DPTR,#0000H
        LCALL   SCP
        MOV     R7,#240         ;240 CHARACTERS
CCM1:   MOV     R1,#20H         ;SEND ASCII BLANK 20H
        LCALL   WRCHR
        DJNZ    R7,CCM1
        RET
;*****************************************
; INTITIAL GRAPHIC LCD DISPLAY 240 X 64
;*****************************************
INITG:  MOV     R0,#00H
        MOV     R1,#00110010B        
        LCALL   WRI
        MOV     R0,#01H
        MOV     R1,#07H              ;8 BITS(Dots) / BETYS 
        LCALL   WRI
        MOV     R0,#02H
        MOV     R1,#29               ;30 BYTES(30 Dots/BYTE) / LINE
        LCALL   WRI
        MOV     R0,#03H
        MOV     R1,#63               ;DISPLAY DUTY = 1/65 or VER. SCAN 65 DOT.
        LCALL   WRI                  
        LCALL   STADD
        RET
;*****************************************
; INTITIAL CHAR MODE
;*****************************************
INITC:  MOV     R0,#00H
        MOV     R1,#00111100B        ;CHARACTER MODE ,CURSOR BLINK
        LCALL   WRI
        MOV     R0,#01H
        MOV     R1,#0A5H             ;Vert. Pitch = 1, Horz. Pitch = 1 
        LCALL   WRI
        MOV     R0,#02H
        MOV     R1,#39               ;40 CHAR / LINE
        LCALL   WRI
        MOV     R0,#03H
        MOV     R1,#63               ;DISPLAY DUTY = 1/65 or SCAN 65 DOT VERT.
        LCALL   WRI                  
        MOV     R0,#04H
        MOV     R1,#08H              ;CURSOR POSITION = 9
        LCALL   WRI
        MOV     DPTR,#0000H          ;CURSOR START AT 0000H
        LCALL   STADD
        RET
;****************************************
; SET CURSOR ADDRESS
; INPUT :DPTR
;****************************************      
SCP:    MOV     R0,#0AH              ;LOWER ADDRESS OF CURSOR
        MOV     R1,DPL              
        LCALL   WRI
        MOV     R0,#0BH              ;UPPER ADDRESS OF CURSOR
        MOV     R1,DPH
        LCALL   WRI
        RET
;********************************
; WRITE ONE CHARACTOR
; INPUT :R1  
;********************************
WRCHR:  MOV     R0,#0CH              ;WRITE CHRARACTER
        LCALL   WRI
        RET
;********************************
; WRITE STRING
; INPUT :DPTR
;********************************
WRST:   MOV     A,#00H
        MOVC    A,@A+DPTR
        INC     DPTR                
        CJNE    A,#00H,NEXT
        SJMP    OUT
NEXT:   MOV     R1,A
        LCALL   WRCHR
        SJMP    WRST
OUT:    RET
;********************************
; SET START ADDRESS FOR DISPLAY
; INPUT : DPTR
;********************************
STADD:  MOV     R0,#08H
        MOV     R1,#00H               ;LOWER START ADDRESS
        LCALL   WRI
        MOV     R0,#09H
        MOV     R1,#00H               ;UPPER START ADDRESS
        LCALL   WRI
        RET
;********************************
; WRITE INSTRUCTION AND DATA
; INPUT : R0 ==> INSTRUCTION
;         R1 ==> DATA
;********************************
WRI:    PUSH    DPL
        PUSH    DPH
        ACALL   RDF
        MOV     DPTR,#0E0C2H
        MOV     A,R0            ;WRITE INSTRUCTION
        MOVX    @DPTR,A
        MOV     DPTR,#0E0C0H
        MOV     A,R1            ;WRITE DATA
        MOVX    @DPTR,A
        POP     DPH
        POP     DPL
        RET
;*******************************
;READ BUSY FLAG
;*******************************
RDF:    MOV     DPTR,#0E0C3H
DF:     MOVX    A,@DPTR
        JB      ACC.7,DF
        RET
;*******************************
;DISPLAY OFF
;*******************************
DOFF:   MOV     R0,#00H         ;instruction 1 :CODE 00H
        MOV     R1,#00010010B       ;display off
        CALL    WRI
        RET
;*******************************
;DISPLAY ON
;*******************************
DON:    MOV     R0,#00H         ;instruction 1 :CODE 00H
        MOV     R1,#00110010B       ;display off
        CALL    WRI
        RET
;*******************************
;DELAY 1
;*******************************
DELAY:  MOV     R2,#00H
AAS:    MOV     R3,#0H
        DJNZ    R3,$
        DJNZ    R2,AAS
        RET
;********************************
;DELAY 2
;********************************
DEL:    MOV     R4,#10
DEL1:   CALL    DELAY
        DJNZ    R4,DEL1
        RET
;********************************
TABSTR1: DB     "GRAPHIC LCD MODULE  DG-24064",00H
TABSTR2: DB     "240 X 64 Dots",00H
TABSTR3: DB     "With LED BACKLIGHT",00H
TABSTR4: DB     "THIS IS CHARACTER MODE",00H
TABSTR5: DB     "ETT CO.,LTD.",00H
;*********************************************************************
PATG1:   DB      00001000B,00000000B,00000000B,00000000B,00000000B
         DB      00011100B,00000000B,00000000B,00000000B,00000000B
         DB      00111110B,00000000B,00000000B,00000000B,00000000B
         DB      01111111B,00000000B,00000000B,00000000B,00000000B
         DB      00011100B,00000000B,00000000B,00000000B,00000000B
         DB      11111100B,00000000B,00000000B,00000000B,00000000B
         DB      00011100B,00000000B,00000000B,00000000B,00000000B
         DB      00011100B,00000000B,00000000B,00000000B,00000000B
         DB      00011100B,00000000B,00000000B,00000000B,00000000B
         DB      00011100B,00000000B,00000000B,00000000B,00000000B
         DB      00011100B,00000000B,00000000B,00000000B,00000000B
         DB      00011100B,00000000B,00000000B,00000000B,00000000B
         DB      00011100B,00000000B,00000000B,00000000B,00000000B
         DB      00011100B,00000000B,00000000B,00000000B,00000000B
         DB      00011100B,00000000B,00000000B,00000000B,00000000B
         DB      11111100B,00000000B,00000000B,00000000B,00000000B
         DB      00011100B,00000000B,00000000B,00000000B,00000000B
         DB      00011100B,00000000B,00000000B,00001000B,00000000B
         DB      00011100B,00000000B,00000000B,01100011B,00000000B
         DB      00011100B,00000000B,00000011B,00000000B,00000001B
         DB      00011100B,00000000B,00000000B,00000000B,11000110B
         DB      00011100B,00000000B,00000000B,00000000B,00011000B
         DB      00011110B,00000000B,00011000B,00000000B,00000000B
         DB      00011101B,00000000B,00110000B,00000000B,00000000B
         DB      00011100B,10000000B,11000000B,00000000B,00000000B
         DB      11111100B,00010000B,11000000B,00000000B,00000000B
         DB      00011100B,00000110B,00000000B,00000000B,00000000B
         DB      00011100B,00000000B,00000000B,00000000B,00000000B
         DB      00011100B,00000000B,00000000B,00000000B,00000000B
         DB      00011100B,00000000B,00000000B,00000000B,00000000B
         DB      00011100B,00000000B,00000000B,00000000B,00000000B
         DB      00011100B,00000000B,00000000B,00000000B,00000000B
         DB      00011100B,00000000B,00000000B,00000000B,00001000B
         DB      00011100B,00000000B,00000000B,00000000B,00001100B
         DB      00011111B,11111111B,11111111B,11111111B,11111110B
         DB      00011111B,11111111B,11111111B,11111111B,11111111B
         DB      00011111B,11111111B,11111111B,11111111B,11111110B
         DB      00000000B,00000000B,11000000B,00000011B,00001100B
         DB      00000000B,00000000B,11000000B,00000011B,00001000B
         DB      00000000B,00000000B,11000000B,00000011B,00000000B
;*********************************************************************
        END
                 

