*********************************
* Demo For  : Graphic LCD DV-12864
* HardWare  : Board ET-CP68HC11
* Assembler : AS11NEW
* Function  : Sine Wave Picture
**************************

WR_COMM1    EQU     $1400       ; Write Instruction Page1
RD_COMM1    EQU     $1400       ; Reda Busy flag & Address Page1
WR_DATA1    EQU     $1401       ; Write Data Page1
RD_DATA1    EQU     $1401       ; Read Data Page1
;
WR_COMM2    EQU     $1410       ; Write Instruction Page2
RD_COMM2    EQU     $1410       ; Reda Busy flag & Address Page2
WR_DATA2    EQU     $1411       ; Write Data Page2
RD_DATA2    EQU     $1411       ; Read Data Page2

            ORG     $2200
MAIN        JSR     INITGLCD    ; Initial Graphic LCD
            LDAA    #8
            STAA    LINE_CNT    ; Counter Line
            LDX     #LINE1      ; Table Font Thai & English
            ;
NEW_LINE    JSR     SET_X1      ; Set X_Address Page1
            JSR     SET_Y1      ; Set Y_Address Page1
            LDAB    #64         ; Counter Y Position Page1
WR_PAGE1    JSR     BUSY_LCD1
            LDAA    0,X
            STAA    WR_DATA1
            INX
            DECB
            BNE     WR_PAGE1
            ;
            JSR     SET_X2      ; Set X_Address Page2
            JSR     SET_Y2      ; Set Y_Address Page2
            LDAB    #64         ; Counter Y Position Page2
WR_PAGE2    JSR     BUSY_LCD2
            LDAA    0,X
            STAA    WR_DATA2
            INX
            DECB
            BNE     WR_PAGE2
            ;
            INC     X_ADDR1     ; Next Line Page1
            INC     X_ADDR2     ; Next Line Page2
            DEC     LINE_CNT
            BNE     NEW_LINE
            JMP     *           ; Loop Here


**********************
* Initial Graphic LCD
**********************
INITGLCD    LDAA    #$3F        ; Display on-off  X=1 ON,X=0 OFF
            JSR     BUSY_LCD1
            STAA    WR_COMM1    ; Set Display ON Page1
            JSR     BUSY_LCD2
            STAA    WR_COMM2    ; Set Display ON Page2
            LDAA    #$C0
            JSR     BUSY_LCD1
            STAA    WR_COMM1    ; Display Strat Page1
            JSR     BUSY_LCD2
            STAA    WR_COMM2    ; Display Start Page2
            CLRA
            STAA    X_ADDR1     ; Start X-Address1 = 0
            STAA    X_ADDR2     ; Start X-Address2 = 0
            STAA    Y_ADDR1     ; Start Y-Address1 = 0
            STAA    Y_ADDR2     ; Start Y-Address2 = 0
            RTS

*****************
* Set X-Address1
* Input : X_ADDR1
*       : (0..7)
*****************
SET_X1      PSHA
            JSR     BUSY_LCD1       ; Wait LCD busy
            LDAA    X_ADDR1
            ANDA    #$07
            ORAA    #$B8
            STAA    WR_COMM1        ; Set X-Address Page1
            PULA
            RTS

*****************
* Set X-Address2
* Input : X_ADDR2
*       : (0..7)
*****************
SET_X2      PSHA
            JSR     BUSY_LCD2       ; Wait LCD busy
            LDAA    X_ADDR2
            ANDA    #$07
            ORAA    #$B8
            STAA    WR_COMM2        ; Set X-Address Page2
            PULA
            RTS

*****************
* Set Y-Address1
* Input : Y_ADDR1
*       : (0..63)
*****************
SET_Y1      PSHA
            JSR     BUSY_LCD1       ; Wait LCD busy
            LDAA    Y_ADDR1
            ANDA    #63
            ORAA    #$40
            STAA    WR_COMM1        ; Set Y-Address Page1
            PULA
            RTS

*****************
* Set Y-Address2
* Input : Y_ADDR2
*       : (0..63)
*****************
SET_Y2      PSHA
            JSR     BUSY_LCD2       ; Wait LCD busy
            LDAA    Y_ADDR2
            ANDA    #63
            ORAA    #$40
            STAA    WR_COMM2        ; Set Y-Address Page2
            PULA
            RTS

**********************
* Read Busy Flag LCD1
**********************
BUSY_LCD1   PSHA
BUSY1       LDAA    RD_COMM1
            ANDA    #$80
            BNE     BUSY1           ; Check Busy Flag
            PULA
            RTS

**********************
* Read Busy Flag LCD2
**********************
BUSY_LCD2   PSHA
BUSY2       LDAA    RD_COMM2
            ANDA    #$80
            BNE     BUSY2           ; Check Busy Flag
            PULA
            RTS

LINE1       FCB     $FF,$FF,$07,$0B,$F3,$13,$13,$13
            FCB     $13,$13,$13,$13,$13,$13,$13,$13
            FCB     $13,$13,$13,$13,$13,$13,$13,$13
            FCB     $13,$13,$13,$13,$13,$13,$13,$13
            FCB     $13,$13,$13,$13,$13,$13,$13,$13
            FCB     $13,$13,$13,$13,$13,$13,$13,$13
            FCB     $13,$13,$13,$13,$13,$13,$13,$13
            FCB     $13,$13,$13,$13,$13,$13,$13,$13
            FCB     $13,$13,$13,$13,$13,$13,$13,$13
            FCB     $13,$13,$13,$13,$13,$13,$13,$13
            FCB     $13,$13,$13,$13,$13,$13,$13,$13
            FCB     $13,$13,$13,$F3,$0B,$07,$FF,$FF
            FCB     $03,$03,$03,$03,$03,$03,$03,$03
            FCB     $03,$03,$43,$83,$03,$03,$03,$E3
            FCB     $03,$03,$83,$43,$03,$03,$03,$03
            FCB     $03,$03,$03,$03,$03,$03,$FF,$FF
LINE2       FCB     $FF,$FF,$00,$00,$FF,$00,$00,$00
            FCB     $00,$80,$60,$18,$04,$02,$01,$01
            FCB     $01,$02,$04,$18,$60,$80,$00,$00
            FCB     $00,$00,$00,$00,$00,$80,$60,$18
            FCB     $04,$02,$01,$01,$01,$02,$04,$18
            FCB     $60,$80,$00,$00,$00,$00,$00,$00
            FCB     $00,$80,$60,$18,$04,$02,$01,$01
            FCB     $01,$02,$04,$18,$60,$80,$00,$00
            FCB     $00,$00,$00,$00,$00,$80,$60,$18
            FCB     $04,$02,$01,$01,$01,$02,$04,$18
            FCB     $60,$80,$00,$00,$00,$00,$00,$00
            FCB     $00,$80,$60,$FF,$00,$00,$FF,$FF
            FCB     $00,$00,$00,$00,$00,$44,$48,$71
            FCB     $1A,$0C,$04,$02,$02,$E1,$11,$51
            FCB     $11,$E2,$02,$04,$0C,$1A,$71,$48
            FCB     $44,$00,$00,$00,$00,$00,$FF,$FF
LINE3       FCB     $FF,$FF,$00,$00,$FF,$08,$08,$04
            FCB     $02,$01,$80,$00,$00,$00,$00,$00
            FCB     $00,$00,$00,$00,$80,$01,$02,$04
            FCB     $08,$08,$08,$04,$02,$01,$80,$00
            FCB     $00,$00,$00,$00,$00,$00,$00,$00
            FCB     $80,$01,$02,$04,$08,$08,$08,$04
            FCB     $02,$01,$80,$00,$00,$00,$00,$00
            FCB     $00,$00,$00,$00,$80,$01,$02,$04
            FCB     $08,$08,$08,$04,$02,$01,$80,$00
            FCB     $00,$00,$00,$00,$00,$00,$00,$00
            FCB     $80,$01,$02,$04,$08,$08,$08,$04
            FCB     $02,$01,$80,$FF,$00,$00,$FF,$FF
            FCB     $00,$00,$00,$00,$00,$00,$00,$40
            FCB     $80,$00,$10,$A0,$80,$40,$41,$79
            FCB     $41,$80,$A0,$10,$00,$80,$40,$00
            FCB     $00,$00,$00,$00,$00,$00,$FF,$FF
LINE4       FCB     $FF,$FF,$00,$00,$FF,$01,$01,$01
            FCB     $01,$01,$E3,$21,$21,$21,$21,$21
            FCB     $21,$21,$21,$21,$E3,$01,$01,$01
            FCB     $01,$01,$01,$01,$01,$01,$E3,$21
            FCB     $21,$21,$21,$21,$21,$21,$21,$21
            FCB     $E3,$01,$01,$01,$01,$01,$01,$01
            FCB     $01,$01,$E3,$21,$21,$21,$21,$21
            FCB     $21,$21,$21,$21,$E3,$01,$01,$01
            FCB     $01,$01,$01,$01,$01,$01,$E3,$21
            FCB     $21,$21,$21,$21,$21,$21,$21,$21
            FCB     $E3,$01,$01,$01,$01,$01,$01,$01
            FCB     $01,$01,$E3,$FF,$00,$00,$FF,$FF
            FCB     $00,$00,$00,$00,$00,$11,$12,$1C
            FCB     $06,$03,$01,$00,$00,$38,$44,$54
            FCB     $44,$38,$00,$01,$03,$06,$1C,$12
            FCB     $11,$00,$00,$00,$00,$00,$FF,$FF
LINE5       FCB     $FF,$FF,$00,$00,$FF,$08,$08,$08
            FCB     $08,$08,$0F,$00,$00,$00,$00,$00
            FCB     $00,$00,$00,$00,$0F,$08,$08,$08
            FCB     $08,$08,$08,$08,$08,$08,$0F,$00
            FCB     $00,$00,$00,$00,$00,$00,$00,$00
            FCB     $0F,$08,$08,$08,$08,$08,$08,$08
            FCB     $08,$08,$0F,$00,$00,$00,$00,$00
            FCB     $00,$00,$00,$00,$0F,$08,$08,$08
            FCB     $08,$08,$08,$08,$08,$08,$0F,$00
            FCB     $00,$00,$00,$00,$00,$00,$00,$00
            FCB     $0F,$08,$08,$08,$08,$08,$08,$08
            FCB     $08,$08,$0F,$FF,$00,$00,$FF,$FF
            FCB     $00,$00,$00,$00,$00,$70,$88,$A8
            FCB     $88,$70,$00,$00,$00,$00,$00,$00
            FCB     $00,$00,$00,$00,$70,$88,$A8,$88
            FCB     $70,$00,$00,$00,$00,$00,$FF,$FF
LINE6       FCB     $FF,$FF,$38,$34,$33,$32,$32,$32
            FCB     $32,$32,$32,$32,$32,$32,$32,$32
            FCB     $32,$32,$32,$32,$32,$32,$32,$32
            FCB     $32,$32,$32,$32,$32,$32,$32,$32
            FCB     $32,$32,$32,$32,$32,$32,$32,$32
            FCB     $32,$32,$32,$32,$32,$32,$32,$32
            FCB     $32,$32,$32,$32,$32,$32,$32,$32
            FCB     $32,$32,$32,$32,$32,$32,$32,$32
            FCB     $32,$32,$32,$32,$32,$32,$32,$32
            FCB     $32,$32,$32,$32,$32,$32,$32,$32
            FCB     $32,$32,$32,$32,$32,$32,$32,$F2
            FCB     $F2,$32,$32,$33,$34,$38,$3F,$3F
            FCB     $30,$30,$30,$30,$30,$30,$30,$30
            FCB     $30,$30,$30,$30,$30,$30,$30,$30
            FCB     $30,$30,$30,$30,$30,$30,$30,$30
            FCB     $30,$30,$30,$30,$30,$30,$FF,$FF
LINE7       FCB     $FF,$FF,$00,$00,$00,$00,$00,$40
            FCB     $20,$20,$20,$C0,$00,$40,$20,$20
            FCB     $20,$C0,$00,$40,$20,$A0,$30,$2A
            FCB     $C6,$00,$48,$AC,$4A,$22,$C4,$48
            FCB     $A0,$14,$0C,$40,$20,$A0,$20,$24
            FCB     $C6,$06,$0A,$F2,$02,$04,$44,$24
            FCB     $A0,$20,$20,$C0,$00,$40,$20,$A0
            FCB     $30,$2A,$C6,$00,$04,$06,$06,$0A
            FCB     $F2,$02,$04,$C4,$24,$A0,$A0,$20
            FCB     $C0,$00,$00,$40,$20,$C0,$00,$00
            FCB     $FC,$00,$00,$00,$00,$00,$00,$FF
            FCB     $FF,$00,$00,$00,$00,$00,$00,$E0
            FCB     $10,$C8,$E8,$E8,$C8,$10,$E0,$00
            FCB     $00,$00,$00,$00,$00,$00,$00,$00
            FCB     $E0,$10,$C8,$E8,$E8,$C8,$10,$E0
            FCB     $00,$00,$00,$00,$00,$00,$FF,$FF
LINE8       FCB     $FF,$FF,$C0,$C0,$C0,$C0,$C0,$C3
            FCB     $C5,$C4,$C4,$C3,$C0,$C3,$C5,$C4
            FCB     $C4,$C3,$C0,$C0,$C3,$C4,$C1,$C2
            FCB     $C7,$C0,$C0,$C0,$C0,$C3,$C4,$C4
            FCB     $C3,$C0,$C0,$C0,$C3,$C4,$C1,$C2
            FCB     $C7,$C0,$C0,$C3,$C4,$C0,$C0,$C3
            FCB     $C4,$C1,$C2,$C7,$C0,$C0,$C3,$C4
            FCB     $C1,$C2,$C7,$C0,$C0,$C0,$C0,$C0
            FCB     $C3,$C4,$C0,$C7,$C1,$C0,$C0,$C0
            FCB     $C7,$C0,$C0,$C2,$C5,$C4,$C4,$C4
            FCB     $C3,$C0,$C0,$C0,$C0,$C0,$C0,$FF
            FCB     $FF,$C0,$C0,$C0,$C0,$C0,$C0,$C1
            FCB     $C2,$C4,$C5,$C5,$C4,$C2,$C1,$C0
            FCB     $C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0
            FCB     $C1,$C2,$C4,$C5,$C5,$C4,$C2,$C1
            FCB     $C0,$C0,$C0,$C0,$C0,$C0,$FF,$FF

            ORG     *
X_ADDR1     RMB     1       ; Buffer X-Address Page1
X_ADDR2     RMB     1       ; Buffer X-Address Page2
Y_ADDR1     RMB     1       ; Buffer Y-Address Page1
Y_ADDR2     RMB     1       ; Buffer Y-Address Page2
LINE_CNT    RMB     1       ; Buffer Line Count (X)

            END
